"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.conv = void 0;
var hex_color_regex_1 = require("hex-color-regex");
var lodash_isplainobject_1 = require("lodash.isplainobject");
var lodash_clonedeep_1 = require("lodash.clonedeep");
// https://github.com/codsen/codsen/blob/main/packages/color-shorthand-hex-to-six-digit/src/main.ts
/**
 * Convert shorthand hex color codes into full
 */
function conv(originalInput) {
    // prevent any input argument mutation:
    var input = (0, lodash_clonedeep_1.default)(originalInput);
    // f's
    // ====================
    function toFullHex(hex, _findings, offset, string) {
        if (string[offset - 1] !== '&' && // consider false positives like &#124;
            hex.charAt(0) === '#') {
            if (hex.length === 4) {
                return "#".concat(hex.charAt(1)).concat(hex.charAt(1)).concat(hex.charAt(2)).concat(hex.charAt(2)).concat(hex.charAt(3)).concat(hex.charAt(3)).toLowerCase();
            }
            if (hex.length === 5) {
                return "#".concat(hex.charAt(1)).concat(hex.charAt(1)).concat(hex.charAt(2)).concat(hex.charAt(2)).concat(hex.charAt(3)).concat(hex.charAt(3)).concat(hex.charAt(4)).concat(hex.charAt(4)).toLowerCase();
            }
        }
        return hex.toLowerCase();
    }
    // action
    // ====================
    if (typeof originalInput === 'string') {
        input = input.replace((0, hex_color_regex_1.default)(), toFullHex);
    }
    else if (Array.isArray(input)) {
        for (var i = 0, len = input.length; i < len; i++) {
            input[i] = conv(input[i]);
        }
    }
    else if ((0, lodash_isplainobject_1.default)(originalInput)) {
        Object.keys(input).forEach(function (key) {
            input[key] = conv(input[key]);
        });
    }
    else {
        return originalInput;
    }
    return input;
}
exports.conv = conv;
